#@ File (label = "Input directory", style = "directory") input
#@ File (label = "channel directory", style = "directory") Channel_Output
#@ File (label = "mask directory", style = "directory") Mask_Output 
	
	// Get the list of files in the input folder
	list= getFileList(input);
	start = getTime();	
	setBatchMode(true);
	for (i = 0; i < list.length; i++) {
		showProgress(i, list.length);
		FilePath = input+"/"+list[i];
		print(list[i]);	
 		run("Bio-Formats Importer", "open=[FilePath] autoscale color_mode=Default rois_import=[ROI manager] view=Hyperstack stack_order=XYCZT");
		depth = nSlices();
		//reduce the size of the z-stacks to reduce the computation time
		run("Size...", "width=512 height=512 depth=" +depth+ " constrain average interpolation=Bilinear");
    		run("Split Channels");
		
		//save the bright field image
		Channel_3 = 3;
		selectImage(Channel_3);
		title_3= getTitle();
		run("EDF Easy ", "quality='2' topology='0' show-topology='off' show-view='off'");	//Running the EDF plugin
		wait(3000);	//if there is limited graphic capacity, for instance on laptops, this step is required
		selectWindow("Output");
		rename(title_3 + "_EDF");
		title_output= getTitle();
		FileName=replace(title_output, ".lsm", "");
		FileName=replace(title_output, "input/", "");
		FileName=replace(title_output, "raw/", "");
		saveAs("Tiff",  Channel_Output + "/" + FileName);
		close();

		//save the fluorescence channel
		Channel_2 = 2;
		selectImage(Channel_2);
		title_2= getTitle();
		run("EDF Easy ", "quality='2' topology='0' show-topology='off' show-view='off'");	//Running the EDF plugin
		wait(3000);	//if there is limited graphic capacity, for instance on laptops, this step is required
		selectWindow("Output");
		rename(title_2 + "_EDF");
		title_output= getTitle();
		FileName=replace(title_output, ".lsm", "");
		FileName=replace(title_output, "input/", "");
		FileName=replace(title_output, "raw/", "");
		saveAs("Tiff",  Channel_Output + "/" + FileName);
		close();

		// save the DNA channel
		Channel_1 = 1;
		selectImage(Channel_1);
		title_1= getTitle();
		run("EDF Easy ", "quality='2' topology='0' show-topology='off' show-view='off'");	//Running the EDF plugin
		wait(3000);	//if there is limited graphic capacity, for instance on laptops, this step is required
		selectWindow("Output");
		rename(title_1 + "_EDF");
		title_output= getTitle();
		FileName=replace(title_output, ".lsm", "");
		FileName=replace(title_output, "input/", "");
		FileName=replace(title_output, "raw/", "");
		saveAs("Tiff", Channel_Output + "/" + FileName);
		
		//Nuclei segmentation & save the mask
		run("Gaussian Blur...", "sigma=4");
		setAutoThreshold("Li dark");
		setOption("BlackBackground", true);
		run("Convert to Mask");
		run("Fill Holes");
		run("Distance Transform Watershed", "distances=[Borgefors (3,4)] output=[16 bits] normalize dynamic=1 connectivity=4");
		MaskName=replace(FileName,"C1-","");
		saveAs("Tiff", Mask_Output + "/" + MaskName +"-dist-watershed");
		run("Reset...", "reset=[Locked Image]");
		run("Reset...", "reset=[Undo Buffer]");
		run("Collect Garbage");
		close("*");
	}
